#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct SearchIngestJobsRequest {
    #[builder(default, into)]
    #[serde(rename = "pageSize", skip_serializing_if = "Option::is_none", default)]
    page_size: Option<i32>,
    #[builder(default, into)]
    #[serde(rename = "nextPageToken", skip_serializing_if = "Option::is_none", default)]
    next_page_token: Option<String>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::IngestJobSearchFilter>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "filter", skip_serializing_if = "Option::is_none", default)]
    filter: Option<Box<super::IngestJobSearchFilter>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::IngestJobSortOptions>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "sort", skip_serializing_if = "Option::is_none", default)]
    sort: Option<Box<super::IngestJobSortOptions>>,
}
impl SearchIngestJobsRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    /// Defaults to 100. Clamped to 1_000 if larger, and to 1 if non-positive.
    #[inline]
    pub fn page_size(&self) -> Option<i32> {
        self.page_size.as_ref().map(|o| *o)
    }
    #[inline]
    pub fn next_page_token(&self) -> Option<&str> {
        self.next_page_token.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn filter(&self) -> Option<&super::IngestJobSearchFilter> {
        self.filter.as_ref().map(|o| &**o)
    }
    /// Defaults to most recent created_at first when omitted.
    #[inline]
    pub fn sort(&self) -> Option<&super::IngestJobSortOptions> {
        self.sort.as_ref().map(|o| &**o)
    }
}
